program fixed_non_el_2
   USE omp_lib
   implicit none
 
   INTEGER , PARAMETER :: m_end = 10000000
   INTEGER :: in, it
   INTEGER :: it_stop = 1000
   INTEGER, DIMENSION (1:m_end) :: matrix_a = 10
   INTEGER, DIMENSION (1:m_end) :: matrix_b = 2
   
   DO it = 1, it_stop
   !$omp parallel num_threads(16)
   !$omp do 
      DO in = 2, m_end
         matrix_a(in) = 2.0 * in * (in - 1)
      END DO
   !$omp end do
   !$omp end parallel
   END DO
   
    DO it = 1, it_stop
   !$omp parallel num_threads(16)
   !$omp do
      DO in = 2, m_end
      matrix_b(in) = matrix_a(in) - matrix_a(in-1)
      END DO
   !$omp end do
   !$omp end parallel
    END DO
   !write(*,*) matrix
   
END program fixed_non_el_2
