program fixed_nowait
   USE omp_lib
   implicit none
 
   INTEGER , PARAMETER :: m_end = 1000000
   INTEGER :: i1, i2, i3, i4, i5, i6, tid
   INTEGER :: it_stop = 1000
   REAL :: blub
   REAL , DIMENSION (1:m_end) :: matrix_a = 10.0
   REAL , DIMENSION (1:m_end) :: matrix_b = 0.0
   REAL , DIMENSION (1:10000, 1:10000)  :: dummy = 0.0
   
   !$omp parallel num_threads(6), private (tid)
   tid = OMP_GET_THREAD_NUM()
   write (*,*) tid
   
   !$omp do 
   DO i1 = 1, it_stop
      DO i2 = 2, m_end
         matrix_a(i2) = sqrt(REAL(i2)) * 2.0 
      
      IF (tid > 2) THEN
      DO i3 = 1, 50
         matrix_b(i3) = sqrt(REAL(tid+i3))
      END DO
      END IF
      END DO
   END DO
   !$omp end do !nowait
   
    write (*,*) 'check1'
    
   !$omp single
   write (*,*) 'single'
   DO i6=1, 10
   DO i4=1, 10000
      DO i5 = 1, 10000
      dummy(i4,i5) =  i4 * i5 
      END DO
   END DO
   END DO
   write (*,*) 'end_single'
   !$omp end single !nowait
   
    write (*,*) 'check 2'
    
   !$omp do
   DO i1 = 1, it_stop
      matrix_b(i1) = matrix_a(i1) + sin(REAL(i1))
      END DO
   !$omp end do
   
   !$omp end parallel
   
   write(*,*) matrix_b(200)
   write(*,*) dummy(10000,1000)
END program fixed_nowait
