program test_collapse
   USE omp_lib
   implicit none
   INTEGER , PARAMETER :: second = 21
   INTEGER , PARAMETER :: third = 500
   INTEGER , PARAMETER :: fourth = 2100
   INTEGER , PARAMETER :: fifth = 4
   INTEGER :: two, three, four, five
   REAL , DIMENSION (1:second, 1:third, 1:fourth, 1:fifth) :: matrix = 10.0

   !$omp parallel num_threads(1)
   !$omp do collapse(1)

   DO five = 1, fifth
      DO four = 1, fourth
         DO three= 1, third
            DO two = 1, second
               matrix(two, three, four, five) = matrix(two, three, four, five) &
               * sin(REAL(two*two))
             END DO
          END DO
       END DO
   END DO

   !$omp end do
   !$omp end parallel

   write(*,*) matrix(2,2,2,2)
END program test_collapse