program private_red

   USE omp_lib
   implicit none

   INTEGER, DIMENSION(10000000) :: arr = 1
   INTEGER :: i, j, sum
   INTEGER :: allsum = 0
   
   sum = 0          
   DO j = 1, 10000
   !$omp parallel num_threads(6), firstprivate (sum)
  
   !$omp do
      DO i = 1, 10000000
         sum = sum + arr(i)
      END DO
   
   !$omp end do
   !$omp critical 
   allsum = allsum + sum
   !$omp end critical
   
   !$omp end parallel
   !write (*,*) allsum
   END DO
   write (*,*) allsum
END program private_red